
import javax.microedition.lcdui.*;

public class KiblaCanvas extends Canvas {
	public SalatTimeMidlet mymidlet;
	private int width_2, height_2;
//	-----------------------------------------------------------------------------
	public KiblaCanvas(SalatTimeMidlet mymidlet) {
		this.mymidlet=mymidlet;
		width_2 = getWidth()/2;
		height_2 = getHeight()/2;
	  }
//	-----------------------------------------------------------------------------
//	 Paint the screen based on the name
		protected void paint (Graphics g) {
			String SS;	
			int lyy, ligne;
			g.setColor(0xffffff);
			g.fillRect(0,  0, width_2*2, height_2*2);
			g.setColor(0x000000);
// dessine compass
			if (mymidlet.salatTimeCanvas.img_compass != null) 
					g.drawImage (mymidlet.salatTimeCanvas.img_compass, width_2, height_2, Graphics.VCENTER | Graphics.HCENTER);
			double imwc, flch, c, s, posx, posy, heureTZ, rf, rp;
			rf=0.55;	// rayon fleche
			rp=0.65;	// rayon soleil/Kaaba
			imwc=width_2;
			flch=10;
			heureTZ=mymidlet.salatTimeCanvas.mr.MyTimeZone+mymidlet.salatTimeCanvas.mr.date.h;
			if (heureTZ<0)	 heureTZ+=24;
			if (heureTZ>=24) heureTZ-=24;
			// crit le jour et l'heure
			g.setFont(Font.getFont( Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL));
			lyy=g.getFont().getHeight();
			g.setColor(0x0000FF);
			g.drawString ("Le "+mymidlet.salatTimeCanvas.mr.Days[mymidlet.salatTimeCanvas.mr.CalculeJour(mymidlet.salatTimeCanvas.mr.T+(mymidlet.salatTimeCanvas.mr.MyTimeZone+12)/24.0/36525.0)]+" "
							+mymidlet.salatTimeCanvas.mr.date.j+"/"+mymidlet.salatTimeCanvas.mr.date.m+"/"+mymidlet.salatTimeCanvas.mr.date.a+"  "+mymidlet.salatTimeCanvas.mr.h2hmiarrondie(heureTZ),
							width_2, lyy-2, Graphics.BASELINE | Graphics.HCENTER);

// dessine le Soleil
			c=Math.cos(mainroutines.M_PI/2-(mymidlet.salatTimeCanvas.mr.Soleil.az-mainroutines.M_PI));
			s=Math.sin(mainroutines.M_PI/2-(mymidlet.salatTimeCanvas.mr.Soleil.az-mainroutines.M_PI));
			posx=width_2+imwc*rp*c; posy=height_2-imwc*rp*s;
			if (mymidlet.salatTimeCanvas.img_soleil != null) 
				g.drawImage (mymidlet.salatTimeCanvas.img_soleil, (int)posx, (int)posy, Graphics.VCENTER | Graphics.HCENTER);
			
			g.setColor(0xFFCC00);
//			Pen->Width = 2;
			g.drawLine((int)width_2, (int)imwc, (int)(width_2+imwc*rf*c), (int)(height_2-imwc*rf*s));	// on dessine le vecteur
			g.drawLine((int)(width_2+imwc*rf*c), (int)(height_2-imwc*rf*s), (int)(width_2+imwc*rf*c-c*flch*0.866-s*flch*0.5), (int)(height_2-imwc*rf*s+s*flch*0.866-c*flch*0.5));
			g.drawLine((int)(width_2+imwc*rf*c), (int)(height_2-imwc*rf*s), (int)(width_2+imwc*rf*c-c*flch*0.866+s*flch*0.5), (int)(height_2-imwc*rf*s+s*flch*0.866+c*flch*0.5));
			// ecrit l'angle du soleil
			double AngleSoleil=mymidlet.salatTimeCanvas.mr.Soleil.az-mainroutines.M_PI;
			if (AngleSoleil < 0)	AngleSoleil+=2*mainroutines.M_PI;
			if (AngleSoleil < 1.5*mainroutines.M_PI) ligne=2*lyy;
				else	ligne=2*height_2-2*lyy-2;
			g.drawString ("Soleil "+(mymidlet.salatTimeCanvas.mr.rd2degmin(AngleSoleil) ),
					1, ligne, Graphics.BASELINE | Graphics.LEFT);
			
// dessine la Kaaba (small)  la direction de la Quibla
			c=Math.cos(mainroutines.M_PI/2-mymidlet.salatTimeCanvas.mr.thetaKibla);
			s=Math.sin(mainroutines.M_PI/2-mymidlet.salatTimeCanvas.mr.thetaKibla);
			posx=width_2+imwc*rp*c; posy=height_2-imwc*rp*s;
			if (mymidlet.salatTimeCanvas.img_kaabas != null) 
				g.drawImage (mymidlet.salatTimeCanvas.img_kaabas, (int)posx, (int)posy, Graphics.VCENTER | Graphics.HCENTER);

			g.setColor(0x000000);
			g.drawLine((int)width_2, (int)imwc, (int)(width_2+imwc*rf*c), (int)(height_2-imwc*rf*s));	// on dessine le vecteur
			g.drawLine((int)(width_2+imwc*rf*c), (int)(height_2-imwc*rf*s), (int)(width_2+imwc*rf*c-c*flch*0.866-s*flch*0.5), (int)(height_2-imwc*rf*s+s*flch*0.866-c*flch*0.5));
			g.drawLine((int)(width_2+imwc*rf*c), (int)(height_2-imwc*rf*s), (int)(width_2+imwc*rf*c-c*flch*0.866+s*flch*0.5), (int)(height_2-imwc*rf*s+s*flch*0.866+c*flch*0.5));
			// ecrit l'angle de la Kibla
			double AngleQuibla=mymidlet.salatTimeCanvas.mr.thetaKibla;
			if (AngleQuibla < 0)	AngleQuibla+=2*mainroutines.M_PI;
			g.drawString ("Quibla "+mymidlet.salatTimeCanvas.mr.rd2degmin(AngleQuibla),
					1, ligne+lyy, Graphics.BASELINE | Graphics.LEFT);
			g.setColor(0x111111);
			g.drawString ("(dans le sens des aiguilles)",width_2, 2*height_2-2, Graphics.BASELINE | Graphics.HCENTER);


			SS="__ Date : "+mymidlet.salatTimeCanvas.mr.Days[mymidlet.salatTimeCanvas.mr.CalculeJour(mymidlet.salatTimeCanvas.mr.T+(mymidlet.salatTimeCanvas.mr.MyTimeZone+12)/24.0/36525.0)]+" "
							+mymidlet.salatTimeCanvas.mr.date.j+"/"+mymidlet.salatTimeCanvas.mr.date.m+"/"+mymidlet.salatTimeCanvas.mr.date.a+"  "
			+mymidlet.salatTimeCanvas.mr.h2hminsec(mymidlet.salatTimeCanvas.mr.date.h)+" h UT"
			+"  TZ (include DST)="+mymidlet.salatTimeCanvas.mr.MyTimeZone;
			System.out.println(SS);

						
			SS="Kibla de ce lieu  partir du Nord :  "+mymidlet.salatTimeCanvas.mr.thetaKibla * mainroutines.rd2deg
						+" ie "+ mymidlet.salatTimeCanvas.mr.rd2degmin(mymidlet.salatTimeCanvas.mr.thetaKibla);
			System.out.println(SS);
//			FormKibla->LabelKibla->Caption=SS;
			SS="Soleil  partir du Nord  " + mymidlet.salatTimeCanvas.mr.h2hmiarrondie(heureTZ)
					+" :  "+ (mymidlet.salatTimeCanvas.mr.Soleil.az * mainroutines.rd2deg -180)
					+"  ie  "+ (mymidlet.salatTimeCanvas.mr.rd2degmin(mymidlet.salatTimeCanvas.mr.Soleil.az-mainroutines.M_PI) );
			System.out.println(SS);
//			FormKibla->LabelSoleil->Caption=SS;
			SS="Angle entre le soleil et la Kibla  "+ mymidlet.salatTimeCanvas.mr.h2hmiarrondie(heureTZ)
			+" :  "+ ((mymidlet.salatTimeCanvas.mr.thetaKibla-mymidlet.salatTimeCanvas.mr.Soleil.az)*mainroutines.rd2deg+180)
			+"  ie  "+ (mymidlet.salatTimeCanvas.mr.rd2degmin(mymidlet.salatTimeCanvas.mr.thetaKibla-mymidlet.salatTimeCanvas.mr.Soleil.az+mainroutines.M_PI));
			
			System.out.println(SS);
//			FormKibla->LabelAngle->Caption=SS;
			System.out.println("    (dans le sens des aiguilles d'une montre)");
			}
//	-----------------------------------------------------------------------------
}
